// Solving transcendental equations
// Bisection Method

// Consider the following transcendental equation: 
// sin(x) = 0

function y = g(x)
    y = sin(x)
endfunction

// We first define an interval over which we know a root exists. 
a = -%pi/4
b =  %pi/2

// We verify that the above interval end-points have different signs:
g(a)
g(b)

for i = 1:20 // 20 iterations
    printf("Iteration number %d\n", i)
    c = (a+b)/2
    if sign(g(c)) == 0 then
        the_root = 0,
        break
    elseif sign(g(c)) == sign(g(a)) then
        a = c
    else
        b = c
    end
end

the_root = c