// Solving polynomial equations
// Regula Falsi Method

// Consider the following polynomial equation: 
// x^2 + x = 1

function y = f(x)
    y = x^2 + x - 1
endfunction

// We first define an interval over which we know a root exists. 
a = 0
b = 5

for i = 1:25 // 10 iterations
    printf("Iteration number %d\n", i)
    c = (f(b)*a - f(a)*b)/(f(b) - f(a))
    if sign(f(c)) == 0 then
        the_root = 0,
        break
    elseif sign(f(c)) == sign(f(a)) then
        a = c
    else
        b = c
    end
end

the_root = c
