// Solving transcendental equations
// Regula Falsi Method

// Consider the following transcendental equation: 
// sin(x) = 0

function y = g(x)
    y = sin(x)
endfunction

// We first define an interval over which we know a root exists. 
a = -%pi/4
b =  %pi/2

for i = 1:20 // 20 iterations
    printf("Iteration number %d\n", i)
    c = (g(b)*a - g(a)*b)/(g(b) - g(a))
    if sign(g(c)) == 0 then
        the_root = 0,
        break
    elseif sign(g(c)) == sign(g(a)) then
        a = c
    else
        b = c
    end
end

the_root = c