// Solving polynomial equations
// Newton Raphson method:

// Consider the following polynomial equation: 
// x^2 + x = 1

function y = f(x)
    y = x^2 + x - 1
endfunction

// Our initial guess:

x(1) = 0

// The derivative:
function y = df(x)
    y = 2*x + 1
endfunction

for i = 2:5 // 4 iterations
    x(i) = x(i-1) - f(x(i-1))/df(x(i-1));
    disp(x(i))
end

the_root = x(i)