// Solving transcendental equations
// Newton Raphson method:

// Consider the following transcendental equation: 
// sin(x) = 0

function y = g(x)
    y = sin(x)
endfunction

// Our initial guess:

x(1) = -%pi/4

// The derivative:
function y = dg(x)
    y = cos(x)
endfunction

for i = 2:5 // 4 iterations
    x(i) = x(i-1) - g(x(i-1))/dg(x(i-1));
    disp(x(i))
end

the_root = x(i)