// Solving a quadratic equation: 

function [x1,x2] = qroots(a,b,c);
    i=%i;  
    D=(b^2)-(4*a*c);
    
    if (D>0)
      
        x1=(-b+D^(1/2))/(2*a);
        x2=(-b-D^(1/2))/(2*a);
    elseif (D==0)
        x1=(-b/(2*a));
        x2=(-b/(2*a));
      
    else
        xr=(-b)/(2*a);
        xi=((-D)^(1/2))/(2*a);
        x1=xr+(i*xi);
        x2=xr-(i*xi);
    end   
endfunction

// Consider the equation: 
//     x^2 + 2x + 5
// The roots are 
//     -1 + 2i and -1 - 2i

// We find them using the above function: 
[x1, x2] = qroots(1, 2, 5)

// We compare them using Scilab's functions: 
roots(poly([5 2 1], 'x', 'c'))