// Polynomial interpolation

// Our data-set: 
x = [0:1:5]'; y = exp(x); // exponent
plot(x, y, 'ro')

xp = [0:0.01:5]';

// We first form the Vandermonde matrix:

V = []
n=length(x);

for i=0:n-1
    V = [V, x.^i];
end

// The coefficients of the polynomial equation are given by:
c = V\y

// The interpolating polynomial is given by:
p  = poly(c, 'a', 'coeff')

// We interpolate the points using the above polynomial
yp = horner(p, xp);

plot(xp, yp, 'b')