mode(-1);
// Numerical Integration
//   Written by
//   Rakhi.R 
//   IIT Bombay


// Composite Trapezoidal Rule - C T rule
// This computes I = integral from a to b f(x) dx using C T rule
// fa , fb are the values of the function f(x) at a and b respectively
// The interval (a,b) is divided into n panels, each of width h
// so h = (b-a)/n
// I is given by I = (fa + 2fx2 + 2fx3 + .....+2fxn + fb)*h/2

exec('func.sci'); // execute the function which defines f(x)
temp_sum = 0;

function I = trapc(a,b,n,fa,fb)
    h = (b-a)/n; // interval
    x(1) = a ;
    for i = 1:n-1
        x(i+1) = x(i) + h;  // finds abscissas each separated by h units
        temp_sum = temp_sum + 2*func(x(i+1)); // finds 2fx1 + .....+2fxn-1 
        // temp_sum is also a vector whose last element gives 
        // 2fx1 + 2fx2 + .....+2fxn-1 
    end
    I = (fa + temp_sum($) + fb)*h/2; // finds I as per the formula
      
endfunction