mode(-1);
// Numerical Integration
//   Written by
//   Rakhi.R 
//   IIT Bombay

//Composite Simpson's 3/8th rule
// This computes I = integral from a to b f(x) dx using this rule
// fa , fb are the values of the function f(x) at a and b respectively
// The interval (a,b) is divided into n panels, each of width h
// so h = (b-a)/n
//n has to be a multiple of 3!
// I is given by
// I = (fa  + 3(fx1 + fx2 + fx4.....+ fxn-1) + 2(fx3 + fx6 +....+ fxn-3) + fb)*3h/8
//If we rename a as x(1), b as x(n+1), (since arrays in scilab start with index of 1)
//I can be written as
//I = (fx1 + 3(fx2 + fx3 +....+ fxn) + 2(fx4 + fx7 +.....+ fxn-2) + fxn+1)*3h/8


exec('func.sci'); // execute the function which defines f(x)

temp_sum = 0;
mult3 = 4; // for separating out values at intervals of 3
function I = simp8(a,b,n,fa,fb)
    h = (b-a)/n; // interval
    x(1) = a ;
    for i = 1:n-1
       x(i+1) = x(i) + h;  // finds abscissas, each separated by h units
       if i+1 == mult3 
          temp_sum = temp_sum + 2*func(x(i+1));
          mult3 = mult3 + 3;
       else
          temp_sum = temp_sum + 3*func(x(i+1));
       end
        // last element of temp_sum gives the value of 
        // 3(fx1 + fx2 + fx4.....+ fxn-1) + 2(fx3 + fx6 +....+ fxn-3)
    end
    I = (fa + temp_sum($) + fb)*3*h/8; // finds I as per the formula
      
endfunction