mode(-1);
// Numerical differentiation
//   Written by
//   Rakhi.R 
//   IIT Bombay

//Example of first order derivative using
//forward difference formula. 
//This uses a set of values of x and the corresponding
//values of y = f(x). x values are equally spaced. 
//a is also an element of the x array
//dy/dx at x = a is given by
//[delta(f(a)) - (1/2)*deltasquared(f(a)) + 
//(1/3)*deltacubed(f(a)) - (1/4)*delta^4(f(a)) +
// (1/5)*delta^5(f(a)) - ....]*(1/h)
// the formula is approximated here till the 5th order delta
// h is the gap between the x values
exec('delta.sci');//function to calculate delta
exec('index.sci');//function to get index
exec('get_deltas.sci');//function to get higher order deltas if exists

x = input("Enter the values of x = ");//x values
y = input("Enter the values of y = ");//y values
a = input("Enter the value of x at which derivative is to be found out = ");
n = index(x,a);//get index of a

N = length(x);// find length of x (or y)
if N <= 1 // if x has only 1 value
  disp("N has to be greater than 1!");
  abort;
end
h = x(2) - x(1); // length of h

delta_1 = delta(y,N);// first oder delta
[delta_2,delta_3,delta_4,delta_5] = get_deltas(delta_1,N);//higher order deltas

f_dash_x = (1/h)*(delta_1(n) - (1/2)*delta_2(n) + (1/3)*delta_3(n) - (1/4)*delta_4(n) + (1/5)*delta_5(n))
//evaluate dy/dx as per the formula
disp("The value of the derivative at a is = ");
disp(f_dash_x);



