// Solving a linear equation using Cramer's rule

// Consider the following system of equations: 
//     2x + y -  z =  8 
//    -3x - y + 2z = -11 
//    -2x + y + 2z = -3 

// We can represent the above system in matrix form as follows: 
//     Ax = b
// where,
A = [ 2  1 -1
     -3 -1  2
     -2  1  2]
// and
b = [ 8
     -11
     -3]

// The values of x, y and z are given, by Cramer's rule, as: 
x = det([b, A(:, [2 3])])/det(A)
y = det([A(:, 1) b A(:, 3)])/det(A)
z = det([A(:, [1 2]), b])/det(A)

// We compare this with the answer that Scilab's internal solver gives:
A\b